﻿<?php
/*
	RSS Extractor and Displayer
	(c) 2007  Scriptol.com - Licence Mozilla 1.1.
	rsslib.php
	
	Requirements:
	- PHP 5.
	- A RSS feed.
	
	Using the library:
	Insert this code into the page that displays the RSS feed:
	
	<?php
	require_once("rsslib.php");
	echo RSS_Display("http://www.xul.fr/rss.xml", 25);
	?>
	
*/
$RSS_Content = array();

function RSS_Tags($item, $type)
{
		$y = array();
		$t = array();
		$i = 0;
		$tnl = $item->getElementsByTagName("title");
		$tnl = $tnl->item(0);
		$title = $tnl->firstChild->data;

		$tnl = $item->getElementsByTagName("link");
		$tnl = $tnl->item(0);
		$link = $tnl->firstChild->data;

		$tnl = $item->getElementsByTagName("enclosure");
		$tnl = $tnl->item(0);
		//trouver comment lire le namespace afin d'obtenir le lien vers l'images
		//$enclosure = $tnl->get_attribute_node('url')->data;
		$enclosure = $tnl->getAttribute('url');

		$tnl = $item->getElementsByTagName("description");
		$tnl = $tnl->item(0);
		$description = $tnl->firstChild->data;
				
		$tnl = $item->getElementsByTagName("creator");
		$tnl = $tnl->item(0);
		$auteur = $tnl->firstChild->data;
		
		$tnl = $item->getElementsByTagName("category");
		$count = $tnl->length;
		
		$tag = "";
		while ($i < $count){
			$tempo = $tnl->item($i);
			$tag .= $tempo->firstChild->data . "£";
			$i++;
		}
		
		$y["title"] = $title;
		$y["link"] = $link;
		$y["enclosure"] = $enclosure;
		$y["description"] = $description;
		$y["type"] = $type;
		$y["creator"] = $auteur;
		$y["category"] = $tag;
		
		return $y;
}


function RSS_Channel($channel)
{
	global $RSS_Content;

	$items = $channel->getElementsByTagName("item");
	
	// Processing channel
	
	$y = RSS_Tags($channel, 0);		// get description of channel, type 0
	array_push($RSS_Content, $y);
	
	// Processing articles
	
	foreach($items as $item)
	{
		$y = RSS_Tags($item, 1);	// get description of article, type 1
		array_push($RSS_Content, $y);
	}
}

function RSS_Retrieve($url)
{
	global $RSS_Content;

	$options = LIBXML_DTDLOAD | LIBXML_NOENT | LIBXML_DTDVALID | LIBXML_NOCDATA;

	//echo $url;
	$Resultat = file_get_contents($url);
	$Resultat = substr($Resultat, 40);
	$Resultat = "<?xml version=\"1.0\" encoding=\"utf-8\" ?><!DOCTYPE xsl:stylesheet [<!ENTITY % definitionXYZ SYSTEM \"definition.dtd\">%definitionXYZ;]>".$Resultat;
	$doc = new DomDocument;

	$doc->loadXML($Resultat);
	$channels = $doc->getElementsByTagName("channel");
	
	$RSS_Content = array();
	
	foreach($channels as $channel)
	{
		 RSS_Channel($channel);
	}
	
}


function RSS_RetrieveLinks($url)
{
	global $RSS_Content;

	$doc  = new DOMDocument();
	$doc->load($url);

	$channels = $doc->getElementsByTagName("channel");
	
	$RSS_Content = array();
	
	foreach($channels as $channel)
	{
		$items = $channel->getElementsByTagName("item");
		foreach($items as $item)
		{
			$y = RSS_Tags($item, 1);	// get description of article, type 1
			array_push($RSS_Content, $y);
		}
		 
	}

}


function RSS_Links($url, $size)
{
	global $RSS_Content;

	$page = "<dl>";

	RSS_RetrieveLinks($url);
	if($size > 0)
		$recents = array_slice($RSS_Content, 0, $size);

	foreach($recents as $article)
	{
		$type = $article["type"];
		if($type == 0) continue;
		$title = $article["title"];
		$link = $article["link"];
		$page .= "<di><a target='blank' href=\"$link\">$title</a></di>\n";			
	}

	$page .="</dl>\n";

	return $page;
	
}



function RSS_Display($url, $size)
{
	include("conf.php");
	global $RSS_Content;
	$opened = false;
	$pagefinal = "";
	$PasseCount = 0;

	RSS_Retrieve($url);
	if($size > 0){
		$recents = array_slice($RSS_Content, 0, $size);
	}
	$lb1 = false;
	foreach($recents as $article)
	{
		$page = "";
		$Valide = true;
		if ($lb1) {
			$tag = $article["category"];
			$Keyword = explode("£",$tag);
			$i = 0;
			while (($i < count($Keyword)-1) AND ($Valide)){
				if (strpos($MotRefuse,$Keyword[$i]) > -1){
					$Valide = false;
				}
				$i++;
			}
			if ($Valide){
				if ($PasseCount < $MaxResult){
					$type = $article["type"];
					if($type == 0)
					{
						if($opened == true)
						{
							$page .="</dl>\n";
							$opened = false;
						}
						$page .="<b>";
					}
					else
					{
						if($opened == false) 
						{
							$page .= "<dl>\n";
							$opened = true;
						}
					}
					$title = $article["title"];
					$link = $article["link"];
					$auteur = $article["creator"];
					$description = $article["description"];
					$enclosure = $article["enclosure"];

					$page .= "<di><table id='Resultat'>";
					
					//Appercu de l'image SVG et lien direct vers le SVG
					if (strpos($ElementVisible,"M") > -1){
						$page .= "<tr valign='top' ><td rowspan='5'>";
						if($enclosure != false){
							$page .= "<a target='blank' href=\"";
							if (strpos($enclosure,".png") > -1){
								$page .= str_replace(".png",".svg",$enclosure)."\"><img src=\"$enclosure\"";
							}elseif (strpos($enclosure,".jpg") > -1){
								$page .= str_replace(".jpg",".svg",$enclosure)."\"><img src=\"$enclosure\"";
							}elseif (strpos($enclosure,".gif") > -1){
								$page .= str_replace(".gif",".svg",$enclosure)."\"><img src=\"$enclosure\"";
							//elseif (strpos($enclosure,".svg") > -1){
							//	$page .= "<a target='blank' href=\"$enclosure\"><img src=\"$enclosure\"  width='50' height='50' /></a>";
							}else{
								$page .= "$enclosure\"><img src=\"np.png\"";
							}
						}
						$page .= " width='$TailleMiniature' height='$TailleMiniature' /></a>";
						$page .= "</td></tr>";
					}

					//Titre du SVG et lien vers la page de l'image sur le site OpenClipArt.
					if (strpos($ElementVisible,"T") > -1){
						$page .= "<tr><td colspan='2'><a target='blank' href=\"$link\">$title</a></td></tr>";
					}
					
					//Nom de l'auteur et fait un lien vers sa fiche, lien hardcoder.
					if (strpos($ElementVisible,"A") > -1){
						$page .= "<tr><td width='80' valign='top'>Auteur : </td><td><a target='blank' href=\"$LienAuteur$auteur\"><b>$auteur</b></td></tr>";
					}
					
					//Description de l'image SVG
					if (strpos($ElementVisible,"D") > -1){
						if($description != false)
						{
							$description = trim($description);
							if (strlen($description) > 0) { 
								$page .= "<tr><td width='80' valign='top'>Description : </td><td>$description</td></tr>";
							}
						}
					}
					
					if (strpos($ElementVisible,"K") > -1){
						$page .= "<tr><td width='80' valign='top'>Mot-clés : </td><td>";
						$i = 0;
						while ($i < count($Keyword)-1){
							$page .= "<a href=\"#\" onclick=\"Recherche('$Keyword[$i]');\">$Keyword[$i]</a>";
							$i++;
							if ($i < count($Keyword)-1){
								$page .= ", ";
							}
						}
						$page .= "</td></tr>";
					}
					
					$page .= "</table></di>\n";			
					
					if($type==0)
					{
						$page .="</b><br />";
					}			
				}
			}
			$PasseCount = $PasseCount + 1;
		}else{
			$lb1 = true;
		}
		if ($Valide){	
			$pagefinal .= $page;
		}else{
			$pagefinal .= "<br><br>résultat rejeté";
		}
	}

	if($opened == true)
	{	
		$pagefinal .="</dl>\n";
	}
	return $pagefinal."\n";
	
}


?>
